Name:		spindle
Version:	0.9
Release:	1%{?dist}
Summary:	Scalable Parallel Input Network for Dynamic Load Environments

License:	LGPLv2
URL:		https://computation-rnd.llnl.gov/spindle/
Source0:	https://github.com/hpc/Spindle/archive/v%{version}.tar.gz

BuildRequires:	gcc-c++ launchmon-devel libgcrypt-devel	munge-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-build


%description
Dynamic linking and loading are widely used in High Performance
Computing (HPC). As HPC applications are becoming increasingly
complex, developers leverage these techniques that are well-suited for
large-scale software development through support for modularization
and computational steering. But the growing trend towards high numbers
of dynamically linked libraries (DLLs) within applications poses
greater challenges to application start-up. During start-up at scale,
a large number of processes simultaneously access many DLLs, which
creates file access storms that overwhelm shared file systems and acts
like site-wide denial-of-service attacks. 

The Scalable Parallel Input Network for Dynamic Loading Environment
(SPINDLE) presents a novel approach that provides a scalable and
transparent dynamic linking and loading environment. SPINDLE extends
the stock dynamic loader (e.g., ld.so) with a scalable file cache
server overlay network. The network forms a forest topology that
allows SPINDLE to use a varying number of communication trees in the
forest, thereby only the roots of the trees perform file operations of
dynamic loading and scalably propagate the results to all other cache
servers. The cached results are then used by SPINDLE clients that
intercept and re-route file operations of the dynamic
loaders. Building on the existing loader auditing interface, system
requires no modifications to either the loader or the application.

%package	devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description	devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q -n Spindle-%version


%build
%_openmpi_load
%configure
make %{?_smp_mflags} V=1


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%_libdir/*.la $RPM_BUILD_ROOT%_libexecdir/%name/*.la


%clean
rm -rf $RPM_BUILD_ROOT

%post -p /bin/ldconfig
%postun -p /bin/ldconfig

%check
# needs resource manager

%files
%defattr(-,root,root,-)
%doc BUG_EMAIL CHANGELOG COPYRIGHT LGPL README
%_bindir/spindle
%_libexecdir/%name/*.so.*
%_libexecdir/%name/spindle*
%_libdir/libspindle.so.*
%_mandir/man1/*

%files devel
%defattr(-,root,root,-)
%_includedir/*
%_libdir/*.so
%_libexecdir/%name/*.so
%_libexecdir/%name/*.a


%changelog
* Thu Jun 26 2014 Dave Love <d.love@liverpool.ac.uk> - 0.9-1
- Update to v0.9
- Add doc files

* Fri Apr 11 2014 Dave Love <d.love@liverpool.ac.uk> - 0.8-1
- Initial packaging
